#ifndef __B_SPLINE_INTERFACE_H__
#define __B_SPLINE_INTERFACE_H__

typedef int bool;

struct point_struc {
  float x;
  float y;
};

struct b_spline_struc;

struct b_spline_struc *b_spline_new();

bool b_spline_add_control_poly_point
(struct b_spline_struc *b_spline, struct point_struc point);

bool b_spline_remove_control_poly_point
(struct b_spline_struc *b_spline, struct point_struc point);

bool b_spline_update_control_poly_point
(struct b_spline_struc *b_spline, struct point_struc point,
 struct point_struc new_point);

int b_spline_get_control_poly_points_count(struct b_spline_struc *b_spline);

struct point_struc b_spline_get_control_poly_point
(struct b_spline_struc *b_spline, int i);

void b_spline_get_control_poly_points
(struct b_spline_struc *b_spline, int *n, struct point_struc **points);

bool b_spline_set_level(struct b_spline_struc *b_spline, int l);

int b_spline_get_level(struct b_spline_struc *b_spline);

void b_spline_get_param_vector
(struct b_spline_struc *b_spline, int *n, float **par_vector);

bool b_spline_set_param_vector
(struct b_spline_struc *b_spline, int n, float *par_vector);

float b_spline_deBoor_base_func
(struct b_spline_struc *b_spline, int i, float u);

struct point_struc b_spline_deBoor_alg
(struct b_spline_struc *b_spline, float u);

#endif
