// class of B-spline curve

#ifndef __BSPLINE_H__
#define __BSPLINE_H__

#include "linalg.h"

// type of all geometric values

typedef float gtype;

class Curve_B_spline {
 protected:
  int control_poly_points_count;
  Vector<gtype> *control_poly_points;
  int level;
  Vector<float> param_vector;
 public:
  Curve_B_spline ();
  ~Curve_B_spline();
  bool addControlPolyPoint(Vector<gtype> point);
  bool removeControlPolyPoint(Vector<gtype> point);
  bool updateControlPolyPoint(Vector<gtype> point, Vector<gtype> new_point);
  int getControlPolyPointsCount() { return control_poly_points_count; }
  Vector<gtype> getControlPolyPoint(int i);
  void getControlPolyPoints(int &n, Vector<gtype> *&points);
  bool setLevel(int l);
  int getLevel() { return level; }
  bool setParamVector(Vector<float> par_vector);
  Vector<float> getParamVector() { return param_vector; }
  gtype deBoorBaseFunc(int i, float u);
  Vector<gtype> deBoorAlg(float u);
 private:
  gtype _deBoorBaseFunc(int k, int i, float u);
  Vector<gtype> _deBoorAlg(int j, int i, float u);
};

#endif
