#include "geom.h"

t_geom_val Curve_Interpolacing::x_on_y (t_geom_val x, uint y)
{
  if (y == 0) return 1;
  else return x * x_on_y (x, y - 1);
}

void Curve_Interpolacing::Create (uint n, uint dim)
{
  level = n - 1;
  coephs = new Vector<t_geom_val> [n] (dim);
  if (coephs == NULL) print_exit (E_MEM_ALLOC);
}

t_error Curve_Interpolacing::EquationSystemMethod (uint n,
					Vector<t_geom_val> *points,
					t_geom_val *par)
{
  uint dim = points[0].GetDim ();
  Create (n, dim);
  Matrix<t_geom_val> matrix (n, n);
  Vector<t_geom_val> column (n), result (n);
  t_error err;
  for (uint k = 0; k < dim; k++) { // for k-th item of vectors own eq. system
    for (uint i = 0; i < n; i++) {
      for (uint j = 0; j < n; j++) matrix.SetItem (i, j, x_on_y (par[i], j));
      column.SetItem (i, points[i].GetItem (k));
    }
    err = SolveEquationSystem (matrix, column, result);
    if (err) return err;
    for (uint i = 0; i < n; i++) coephs[i].SetItem (k, result.GetItem (i));
  }
  return E_OK;
}

void Curve_Interpolacing::GetCoeph (uint i, Vector<t_geom_val> &coeph)
{
  for (uint j = 0; j < coephs[i].GetDim (); j++)
    coeph.SetItem (j, coephs[i].GetItem (j));
}

