// classes of geometric structures

#ifndef _GEOM_INCLUDED_
#define _GEOM_INCLUDED_

#include "linalg.h"

// type of all geometric values

typedef float t_geom_val;

// class of a curve

class Curve_Interpolacing {
 protected:
  Vector<t_geom_val> *coephs;
  uint level;
  void Create (uint n, uint dim);
  t_geom_val x_on_y (t_geom_val x, uint y);
 public:
  Curve_Interpolacing () { coephs = NULL; level = 0; }
  t_error EquationSystemMethod (uint n, Vector<t_geom_val> *points,
				     t_geom_val *par);
  void GetCoeph (uint i, Vector<t_geom_val> &coeph);
  uint GetLevel () { return level; }
};

#endif
